summaryrefslogtreecommitdiff
path: root/Ubuntu
diff options
context:
space:
mode:
Diffstat (limited to 'Ubuntu')
-rw-r--r--Ubuntu/README.md25
-rw-r--r--Ubuntu/executable.md94
-rw-r--r--Ubuntu/ghdl-0.37.tar.xzbin0 -> 2950196 bytes
-rwxr-xr-xUbuntu/install-nghdl.sh242
-rw-r--r--Ubuntu/nghdl.spec32
5 files changed, 393 insertions, 0 deletions
diff --git a/Ubuntu/README.md b/Ubuntu/README.md
new file mode 100644
index 0000000..cbc0adb
--- /dev/null
+++ b/Ubuntu/README.md
@@ -0,0 +1,25 @@
+NGHDL Installer (Ubuntu OS)
+====
+
+It contains the documentation to package NGHDL for Ubuntu OS.
+
+> Note: If planning to freeze the NGHDL source code for a target platform (Ubuntu OS), then refer this [documentation](executable.md). Remember to update the installer script to work with this executable!
+
+## How to package NGHDL for Ubuntu OS?
+
+1. Take the `master` branch containing the source code. Rename the folder to `nghdl`.
+
+2. Add GHDL source code `ghdl-<version>.tar.xz` in the `nghdl` folder.
+
+3. Add the installer script `install-nghdl.sh` in the `nghdl` folder.
+
+4. Add the NGHDL executable (if available) in `nghdl/src` folder. Also, remove following files from this folder:
+ - `.git` folder
+ - all python files (Applicable only if eSim executable is used)
+ - GHDLside.md
+ - Workflow.md
+ - .gitignore
+
+2. Compress it to `.zip` format.
+
+3. Place this compressed file in `eSim-<version>` folder.
diff --git a/Ubuntu/executable.md b/Ubuntu/executable.md
new file mode 100644
index 0000000..9ac54a1
--- /dev/null
+++ b/Ubuntu/executable.md
@@ -0,0 +1,94 @@
+NGHDL Executable (Ubuntu OS)
+====
+
+> Note: It is not updated for the recently ported GUI to PyQt5 and Ubuntu 20.04 LTS. Currently, packaging for Ubuntu OS is done directly with the source code and not the executable.
+
+It contains the documentation for making NGHDL executable using PyInstaller on Ubuntu 16.04 and above.
+
+
+## Freeze NGHDL source code:
+
+1. Download `virtualenv` package and create virtual environment as:
+
+ $ pip install virtualenv
+ $ virtualenv -p /usr/bin/python3 nghdl
+
+ OR
+
+ $ sudo apt install -y python3-venv
+ $ python3 -m venv nghdl
+
+2. Activate the virtual environment as:
+
+ $ source nghdl/bin/activate
+
+3. Install all Python dependencies for NGHDL within the virtual environment as:
+
+ $ pip install wheel
+ $ pip install pyinstaller
+ $ pip install --upgrade 'setuptools<45.0.0'
+ $ sudo apt install build-essential python3-dev libqt4-dev qt4-dev-tools
+ $ mkdir nghdl/build
+ $ cd nghdl/build/
+ $ wget http://sourceforge.net/projects/pyqt/files/PyQt4/PyQt-4.12.3/PyQt4_gpl_x11-4.12.3.tar.gz
+ $ wget https://www.riverbankcomputing.com/static/Downloads/sip/4.19.21/sip-4.19.21.tar.gz
+ $ tar xzvf sip-4.19.21.tar.gz
+ $ tar xvzf PyQt4_gpl_x11-4.12.3.tar.gz
+ $ cd sip-4.19.21/
+ $ python configure.py --sip-module PyQt4.sip
+ $ make
+ $ make install
+ $ cd ../PyQt4_gpl_x11-4.12.3/
+ $ python configure.py
+ $ make
+ $ make install
+
+4. Now uninstall PyQt4, sip, matplotlib, numpy, dateutil and cycler globally (if any).
+
+5. Test whether only NGHDL dependencies are available or not:
+
+ $ pip freeze
+
+> Note : Following dependencies should be available -
+> - PyQt4
+> - sip
+
+6. Create spec file as:
+
+ $ pyi-makespec --onefile -n nghdl <path_to_nghdl>/src/ngspice_ghdl.py
+
+7. Add `PyQt4.sip` as hiddenimports in the generated spec file.
+
+8. Create onefile executable using pyinstaller as:
+
+ $ pyinstaller -F --clean nghdl.spec
+
+9. Verify whether all NGHDL `src` files (`*.py`) have been included in `Analysis-00.toc` file under the build folder generated by PyInstaller.
+
+
+## Fully-Static Bundled Version of NGHDL:
+
+1. To create a [fully-static bundled version](https://github.com/pyinstaller/pyinstaller/wiki/FAQ#GNULinux) of NGHDL (through PyInstaller), use a tool like [StaticX](https://github.com/JonathonReinhart/staticx/).
+
+2. To create fully-static NGHDL :
+
+ - Activate the virtual environment as:
+
+ $ source nghdl/bin/activate
+
+ - Install StaticX as:
+
+ $ pip install staticx
+ $ pip install patchelf-wrapper
+
+ - Create static NGHDL as:
+
+ $ staticx /path/to/executable/nghdl /path/to/output/executable/nghdl
+
+3. To verify if all dynamic libraries are removed :
+
+ - Type following command in a terminal :
+
+ $ ldd path/to/output/executable/nghdl
+
+ - Output of above command should be similar to ` not a dynamic executable`
diff --git a/Ubuntu/ghdl-0.37.tar.xz b/Ubuntu/ghdl-0.37.tar.xz
new file mode 100644
index 0000000..2442cb3
--- /dev/null
+++ b/Ubuntu/ghdl-0.37.tar.xz
Binary files differ
diff --git a/Ubuntu/install-nghdl.sh b/Ubuntu/install-nghdl.sh
new file mode 100755
index 0000000..fcb3eab
--- /dev/null
+++ b/Ubuntu/install-nghdl.sh
@@ -0,0 +1,242 @@
+#!/bin/bash
+#===============================================================================
+# FILE: install-nghdl.sh
+#
+# USAGE: ./install-nghdl.sh --install
+# OR
+# ./install-nghdl.sh --uninstall
+#
+# DESCRIPTION: Installation script for Ngspice and GHDL simulators (NGHDL)
+#
+# OPTIONS: ---
+# REQUIREMENTS: ---
+# BUGS: ---
+# NOTES: ---
+# AUTHOR: Fahim Khan, Rahul Paknikar
+# ORGANIZATION: eSim, FOSSEE group at IIT Bombay
+# CREATED: Tuesday 02 December 2014 17:01
+# REVISION: Sunday 02 August 2020 01:35
+#===============================================================================
+
+set -e # Set exit option immediately on error
+set -E # inherit ERR trap by shell functions
+
+error_exit() {
+ echo -e "\n\nError! Kindly resolve above error(s) and try again."
+ echo -e "\nAborting Installation...\n"
+}
+
+# Trap on function error_exit before exiting on error
+trap error_exit ERR
+
+
+ngspice="ngspice-nghdl"
+ghdl="ghdl-0.37"
+config_dir="$HOME/.nghdl"
+config_file="config.ini"
+src_dir=`pwd`
+
+# Will be used to take backup of any file
+sysdate="$(date)"
+timestamp=`echo $sysdate|awk '{print $3"_"$2"_"$6"_"$4 }'`
+
+
+# All functions goes here
+function installDependency
+{
+
+ echo "Installing dependencies for $ghdl LLVM................"
+
+ echo "Installing Make..........................................."
+ sudo apt install -y make
+
+ echo "Installing GNAT..........................................."
+ sudo apt install -y gnat
+
+ echo "Installing LLVM-8........................................."
+ sudo apt install -y llvm-8
+
+ echo "Installing Clang.........................................."
+ sudo apt-get install -y clang
+
+ echo "Installing Zlib1g-dev....................................."
+ sudo apt install -y zlib1g-dev
+
+ # Specific dependency for canberra-gtk modules
+ echo "Installing Gtk Canberra modules..........................."
+ sudo apt install -y libcanberra-gtk-module libcanberra-gtk3-module
+
+ # Specific dependency for nvidia graphic cards
+ echo "Installing graphics dependency for ngspice souce build"
+ echo "Installing libxaw7........................................"
+ sudo apt install -y libxaw7
+
+ echo "Installing libxaw7-dev...................................."
+ sudo apt install -y libxaw7-dev
+
+
+ echo "Installing $ghdl LLVM................................."
+ tar -xJf $ghdl.tar.xz
+ echo "$ghdl successfully extracted"
+ echo "Changing directory to $ghdl installation"
+ cd $ghdl/
+ echo "Configuring $ghdl build as per requirements"
+ chmod +x configure
+ # Other configure flags can be found at - https://github.com/ghdl/ghdl/blob/master/configure
+ sudo ./configure --with-llvm-config=/usr/bin/llvm-config-8
+ echo "Building the install file for $ghdl LLVM"
+ sudo make
+ sudo make install
+
+ set +e # Temporary disable exit on error
+ trap "" ERR # Do not trap on error of any command
+
+ echo "Removing unused part of $ghdl LLVM"
+ sudo rm -rf ../$ghdl
+
+ set -e # Re-enable exit on error
+ trap error_exit ERR
+
+ echo "GHDL installed successfully"
+
+}
+
+
+function installNgspice
+{
+
+ echo "Installing Ngspice........................................"
+
+ # Extracting Ngspice to Home Directory
+ cd $src_dir
+ tar -xJf $ngspice.tar.xz -C $HOME
+
+ echo "Ngspice extracted sucessfully to $HOME"
+ # Change to ngspice-nghdl directory
+ cd $HOME/$ngspice
+ # Make local install directory
+ mkdir -p install_dir
+ # Make release directory for build
+ mkdir -p release
+ # Change to release directory
+ cd release
+ echo "Configuring Ngspice........."
+ sleep 2
+
+ chmod +x ../configure
+ ../configure --enable-xspice --disable-debug --prefix=$HOME/$ngspice/install_dir/ --exec-prefix=$HOME/$ngspice/install_dir/
+
+ # Adding patch to Ngspice base code
+ cp $src_dir/src/outitf.c $HOME/$ngspice/src/frontend
+
+ make -j$(nproc)
+ make install
+
+ # Make it executable
+ sudo chmod 755 $HOME/$ngspice/install_dir/bin/ngspice
+
+ set +e # Temporary disable exit on error
+ trap "" ERR # Do not trap on error of any command
+
+ echo "Removing previously installed Ngspice (if any)"
+ sudo apt-get purge -y ngspice
+
+ echo "Ngspice installed sucessfully"
+ echo "Adding softlink for the installed Ngspice"
+
+ # Add symlink to the path
+ sudo rm /usr/bin/ngspice
+
+ set -e # Re-enable exit on error
+ trap error_exit ERR
+
+ sudo ln -sf $HOME/$ngspice/install_dir/bin/ngspice /usr/bin/ngspice
+ echo "Added softlink for Ngspice..."
+
+}
+
+
+function createConfigFile
+{
+
+ # Creating config.ini file and adding configuration information
+ # Check if config file is present
+ if [ -d $config_dir ];then
+ rm $config_dir/$config_file && touch $config_dir/$config_file
+ else
+ mkdir $config_dir && touch $config_dir/$config_file
+ fi
+
+ echo "[NGSPICE]" >> $config_dir/$config_file
+ echo "NGSPICE_HOME = $HOME/$ngspice" >> $config_dir/$config_file
+ echo "DIGITAL_MODEL = %(NGSPICE_HOME)s/src/xspice/icm/ghdl" >> $config_dir/$config_file
+ echo "RELEASE = %(NGSPICE_HOME)s/release" >> $config_dir/$config_file
+ echo "[SRC]" >> $config_dir/$config_file
+ echo "SRC_HOME = $src_dir" >> $config_dir/$config_file
+ echo "LICENSE = %(SRC_HOME)s/LICENSE" >> $config_dir/$config_file
+
+}
+
+
+function createSoftLink
+{
+ # Make it executable
+ sudo chmod 755 $src_dir/src/ngspice_ghdl.py
+
+ # Creating softlink
+ cd /usr/local/bin
+ if [[ -L nghdl ]];then
+ echo "Symlink was already present"
+ sudo unlink nghdl
+ fi
+
+ sudo ln -sf $src_dir/src/ngspice_ghdl.py nghdl
+ echo "Added softlink for NGHDL..."
+
+ cd $pwd
+
+}
+
+
+#####################################################################
+# Script start from here #
+#####################################################################
+
+### Checking if file is passsed as argument to script
+
+if [ "$#" -eq 1 ];then
+ option=$1
+else
+ echo "USAGE : "
+ echo "./install-nghdl.sh --install"
+ exit 1;
+fi
+
+## Checking flags
+if [ $option == "--install" ];then
+
+ #Calling functions
+ installDependency
+ if [ $? -ne 0 ];then
+ echo -e "\n\n\nERROR: Unable to install required packages. Please check your internet connection.\n\n"
+ exit 0
+ fi
+ installNgspice
+ createConfigFile
+ createSoftLink
+
+elif [ $option == "--uninstall" ];then
+ sudo rm -rf $HOME/ngspice-nghdl $HOME/.nghdl /usr/share/kicad/library/eSim_Nghdl.lib /usr/local/bin/nghdl /usr/bin/ngspice
+ echo "Removing libxaw7-dev..............."
+ sudo apt purge -y libxaw7-dev
+ echo "Removing GHDL......................"
+ sudo rm -rf /usr/local/bin/ghdl /usr/local/bin/ghdl1-llvm /usr/local/lib/ghdl /usr/local/lib/libghdlvpi.so /usr/local/include/vpi_user.h
+ echo "Removing LLVM......................"
+ sudo apt-get purge -y llvm-8
+ echo "Removing GNAT......................"
+ sudo apt purge -y gnat
+else
+ echo "Please select the proper operation."
+ echo "--install"
+ echo "--uninstall"
+fi
diff --git a/Ubuntu/nghdl.spec b/Ubuntu/nghdl.spec
new file mode 100644
index 0000000..61f3fa8
--- /dev/null
+++ b/Ubuntu/nghdl.spec
@@ -0,0 +1,32 @@
+# -*- mode: python ; coding: utf-8 -*-
+
+block_cipher = None
+
+a = Analysis(['nghdl/src/ngspice_ghdl.py'],
+ pathex=['/home/rahul/Music'],
+ binaries=[],
+ datas=[],
+ hiddenimports=['PyQt4.sip'],
+ hookspath=[],
+ runtime_hooks=[],
+ excludes=[],
+ win_no_prefer_redirects=False,
+ win_private_assemblies=False,
+ cipher=block_cipher,
+ noarchive=False)
+pyz = PYZ(a.pure, a.zipped_data,
+ cipher=block_cipher)
+exe = EXE(pyz,
+ a.scripts,
+ a.binaries,
+ a.zipfiles,
+ a.datas,
+ [],
+ name='nghdl',
+ debug=False,
+ bootloader_ignore_signals=False,
+ strip=False,
+ upx=True,
+ upx_exclude=[],
+ runtime_tmpdir=None,
+ console=True )